#include <emsg: see ... '~$ sh aaa.sh.c -h'   (other opt:no/-m/-w/)>	/*
C='^[/][/*]SH_'     ;O=${0##*[/]};R=`dirname $0`;R=${R%/}/;R0=$R$O;R=$R${O%%.*}
O=${0##*.};Rs=$R.$O;Rm=$R.tmp.$O;Rh=$R.h;R=$Rs$Rh$Rm;Rp='printf %s\n ';Rc=:;O="
";[ "${R##*$R0*}" = '' ]&&$Rp"$0:NGsuffix"&&exit 1;R='sed -ne ';Cm=$R'"/[E]ND/!d
:l;n;p;bl"<$R0>$Rm;$Rp"$Rm"';RB=$($R"s/${C}OP//p"<$R0|(F=mw;while read -r a b;do
B=${a%:};F=`$Rp"$F"|$R"s#$B:*##1;p"`${a%_};$Rp"C$B=\$(cat<<'E'$O$b${O}E$O)";done
$Rp"R1=$F"));Rw=$R'"/$C$R/!d;:l;n;/${C}ED/q;p;bl"<$R0';Cw="(R=LS;$Rw;$Rw>&3;R=HD
$Rw;R=SC;$Rw>&3)"'>$Rh 3>$Rs;$Rp"$Rh $Rs"';Re=eval\ ;$Re"$RB";while getopts $R1\
 R;do case $R in \?)exit 1;;*)$Re"O$R=\$OPTARG";Rc=$Rc$O`$Re'$Rp"$C'$R\"`;;esac
done;[ "$Rc" = : ]&&Rc=$Cm;shift $((OPTIND-1));$Re"$C_$O$Rc";exit   #END GPL3+*/

/*SH_LS*/
/* Copyright (C) 2021 Momi-g

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
/*SH_ED*/

/*SH_HD*/
/*SH_doc
title=bootlj section=1 repnl=\040
@name	bootlj
@_brief	portable luajit script bootloader
@_syno
	bootlj [-J passopt... -J] [args...]
@tl;dr
	@(code)
	- dir1 -+- bootlj
	        +- main.lua	( require("myutil") )
	        +- myutil.lua
	---
	dir1 $ ./bootlj -h	#>> luajit -- main.lua -h
	dir1 $ cd ..
	     $ ./dir1/bootlj	#>> run ./dir1/main.lua
	     $ cd dir1
	dir1 $ rm main.lua
	dir1 $ ./bootlj	#>> main.lua not found
	
	(make symbolic link to dir1/bootlj at /usr/bin etc)
	
	home $ bootlj	#>> run main.lua
	@()
@_opt
	@(list_o)
	-J passopt... -J:	pass opt to luajit vm. ~$ luajit '_passopt...'
	@()
@_desc
	bootlj is a wrapper of luajit runner with the following	features:
	@(code)--@
	- exec `main.lua` in the same directory
	- add the bootlj exist dirpath to package.path and cpath
	- add useful global vars
	  * FULL_BOOTFILE	(fullpath filename, /home/abc/bootlj etc)
	  * BASE_BOOTFILE	(filename: bootlj etc, no dirpath)
	  * FULL_BOOTDIR	(fullpath dirname, c:\home\dir etc.)
	  * FULL_CWD	(fullpath cwd, /home/now etc)
	  * DIRSEP		(directory sepstr, win==\, other==/ etc)
	@()--
	
	this feature makes your app package portable, directory == app.
	lua and luajit path/cpath dont have bootfile exist dirpath so causes
	the path search problem. bootlj resolves it.
	@(code)
	- dir1 -+- src.lua ( require("myutil") )
	        +- myutil.lua
	
	dir1$ luajit src.lua	#>> work
	dir1$ cd ../
	    $ luajit ./dir1/src.lua	#>> misses myutil.lua
	@()--
	
	the best practice for making your luajit code portable is:
	@(list)
	-: use require("foo") for import foo.lua. loaded from the appdir or other path
	-: use package.searchpath("myutil", package.cpath) and ffi.load(rtnstr)
		to load libmyutil.so etc.
	-: use ffi.load("directX") to load major library, libdirextX.so etc
	-: use ffi.C.printf() if use standard C-lib funcs
	-: place every related files(*.lua *.so *.dll) in a non-nested one directory.
		@(code)@
		dir1-+- bootlj
		     +- main.lua
		     +- main_impl.lua
		     +- foo.lua
		     +- tool.lua
		     +- libmyutil.so
		     +- xyz.dll
		@()
	@()--

	bootlj holds whole the orig-luajit vm. the below works almost the same.
		@(code)
	~$ ./bootlj -h
	~$ luajit -- main.lua -h
		@()--
	
	luajit vm accepts commandline options.(https://luajit.org/running.html)
	if you want to run luajit with its options, put between optsep str.
	default optsep is "-J".
		@(code) 
	~$ ./bootlj -J -Ohotloop=10 -joff -J -h
	~$ luajit -Ohotloop=10 -joff -- main.lua -h
		@()--
	
	you can change bootfile name `main.lua` and optsep `-J` using libbootlj.a.
	see bootlj.h
		@(code)--
	//basic
	#include "bootlj.h"
	int main(int argc, char** argv){
	  return bootlj_main(argc, argv);
	}
	//~$ cc -Wall -pedantic -static -fPIC src.c libbootlj.a -ldl -lm
	//~$ ./a.out -J -Ohotloop=10 -J -h 

	#include "bootlj.h"
	int main(int argc, char** argv){
	  return bootlj_main(argc, argv, "xyz.txt", "123");
	}
	//~$ cc src.c libbootlj.a -ldl -lm
	//~$ ./a.out 123 -Ohotloop=10 123 -h	#>> search xyz.txt and run
		@()
@return_value
	exit code depends on main.lua script and follows lua@'s method.
	@(code)@
	- rtn 1 if lj rtns nil/false/err at ag1. (lj)return nil >> $?=1
	- rtn int if lj return num at ag1. (lj)return 8.2 >> $?=8
	- rtn 1 if lj return other type at ag1. (lj)return "msg" >> $?=1
	- emsg to stderr if err or str at ag2. (lj)return 0,"hw" >> $?=0 +'hw'
	@()--
	
@notes
	---concept
	@(code)@
	- make luacode/binary/library portable
	- support to the powerful api, require()/ffi.load()
	- files in the same directory *SHOULD* be searched/loaded
	@()

@conforming_to posix-2001+
@copyright Copyright 2020 momi-g, GPLv3+
@_ver 2021-08-21
@_see 
	@(code)@
	https://luajit.org/index.html
	https://www.lua.org/manual/5.1/manual.html
	@()--
	luajit bases lua 5.1(+appropriate extented) syntax. avoid 5.2/5.3/5.4.
	orig-lua frequently changes syntax that ignores backwards compatibility like
	python2 >> 3, win7 >> 10, perl5 >> 6 etc. i recommend you to use luajit
	instead of orig-lua.
//SH_docE*/
/*SH_ED*/

/*SH_ED*/

/*SH_SC*/
#include "bootlj.h"	/*SH_co* libbootlj.a -ldl -lm */
int main(int argc, char** argv){ return bootlj_main(argc, argv); }

#ifdef TEST
	#include <assert.h>
	#include "hcut.h"
	#include "msgp.h"
	#include "laptime.h"
	#define loop(a)		for(int lpcnt=0;lpcnt<a;lpcnt++)
	#define qu(...)		Qsub(__VA_ARGS__)
	#define Qsub(...)	#__VA_ARGS__
#endif

#ifdef TEST
HCUT_ADD(t_bootlj_cmd) {
	puts("dummy");
}
#endif

#ifdef TEST
HCUT_RUN("stderr", 1,	/* keep newline. use for SH sed edit, -t test.*/
t_bootlj_cmd);
#endif

/*SH_SMP
#include "bootlj.h"
int main(int argc, char** argv){ return bootlj_main(argc, argv); }
//	~$ gcc smpl.c *SH_bn*.c

//SH_SMPE*/

/*SH_ED*/

/*
 change log
 --
2021-08-21  Momi-g	<dmy@dmy.dmy>

	* *SH_bn*.c (doc): make mandoc.

2021-04-19  Momi-g	<dmy@dmy.dmy>

	* *SH_bn*.c (main): separate main() from bootlj.sh.c

*/
/*SH_ED*/

/*SH_OP _ set -e;a=`sed -ne "/${C}DF/!d;:l;n;/${C}DE/q;p;bl"<$R0`;eval "$a"	#*/
/*SH_OP	h $p"-tsbS:test/eg/.o/.so -LMP:leak,mem,prof -f:funcs -o:bldout		GPLv3+"	 #*/
/*SH_OP	f sed -ne "/${C}DF/q;/;/d;/^[a-z].*)/p"<$R0 #*/
/*SH_OP t $e"$CW";ftt "$@";$p'cc -O0 -static -Wall -pedantic -g -pg -ggdb3 $Rm `fOI $Rs $tf` `fg $Rs $tf` `fL`'|fv	#*/
/*SH_OP T $e"$CW";ftt "$@";$p'cc -O3 $Rm `fOI $Rs $tf ` `fg $Rs $tf ` `fL`'|fv	#*/
/*SH_OP s $e"$CB";fgr0 "${C}SMP" "${C}SMPE"<$Rs|fbn>eg.c;$p'cc eg.c `fg eg.c` `fOI eg.c`'|fv #*/

/*SH_OP L $p"valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes --verbose ./a.out 2>&1|sed -e '/SUMMA/!d;n;n;n;n'"|fv #*/
/*SH_OP M $p"fM ./a.out"|fv	 #*/
/*SH_OP P $p'valgrind --tool=callgrind --callgrind-out-file=log.out ./a.out;kcachegrind log.out'|fv	 #*/

/*SH_OP b $e"$CW";$p"cc ${1--c} $Rs -pedantic -O2 -Wall -g `fg $Rs` `fI $Rs`"|fv	#*/
/*SH_OP B $e"$Cb";$p"ar -r lib$bn.a $bn.o `fO $Rs`"|fv;$p"lib$bn.a"	#*/
/*SH_OP A $e"$CB";$p'fA lib$bn.a `fg $Rh $Rs|fu|grep '[.]a$'|fU`'|fv;$p"lib$bn.a" #*/
/*SH_OP S $e"$Cb";$p"cc -shared -fPIC -o lib$bn.so $bn.o `fOI $Rs` `fg $Rs`"|fv;$p"lib$bn.so" #*/
/*SH_OP W $e"$Cm$O$Cw">/dev/null;$i0;$i1;$p"$Rs $Rh $tf"	#*/
/*SH_OP o $p'fman $R0 1'|fv		#*/

/*SH_DF
#-- noob
fman()(bn=bootlj
 $p"fgr0 '${C}doc' '${C}docE'<$1|amn >$bn.$2
 mandoc -Thtml <$bn.$2 >$bn.$2.html
 #fgr0 '${C}doc' '${C}docE'<$1|amn -Dzwsp=1 >$Rm
 #man -Tutf8 /dev/stdin<$Rm|sed -e 's/.`printf \"\\b\"`//g'>$bn.$2.txt
 "|fv
)

#-- local

#-- vars
bn=`basename ${Rs%.*}`; tf=${Rs%/*}/${bn}.ts.${Rs##*.}; e="eval "; p="$Rp"
#-- mod
fv()(while read -r a;do $e"cat<<E$O# $a${O}E"|sed -e 's@-L.*-L[^ ]*@-L(omit)@g'>/dev/stderr;$e"$a";done)

fbn()(sed -e "s@\*${C##*]}bn\*@$bn@g"|frf)
fsn()(tr -s ' \t' '\n')
fsl()(tr -s '\n' ' ')
fu()(fsn|sort -u)
fU()(fu|fsl;$p)

fgr()(sed -e "/$1/!d;:l;/$2/{p;d};n;bl")	#切出
fgr0()(sed -ne "/$1/!d;:l;n;/$2/d;p;bl")	#抜き切出
fgR()(sed -ne "/$1/bl;p;d;:l;n;/$2/d;bl")	#切すて
fg()(sed -ne "s/.*${C##*]}co\*\([^*]*\).*$/\1/p" "$@"|fsn|awk '!a[$0]{a[$0]=1;print}'|fsl)

# fO src.o from inc"src.abc" etc. kick self
fO()(set -- `fdp "$@"|awk '$0~/[.](h|hpp)$/{print}'|sed -e 's/[.][^.]*$/.o/'|fU`
	buf="";for i;do test -f $i&&buf="$buf $i";done;$p"$buf"
)
fI()(fdp "$@"|sed -e 's/[^/]*$//g'|fu|sed -e '/./s/^/ -I/g'|fu|grep -v '^\-I$'|fU)
fL()(find -L `dirname $R0` -type d|sed -e 's/^/-L/g'|fU)
# inc""系.h,hpp,oをパス付きで羅列 OIはfdpが重複するので高速化でまとめる 複数file_ok
fOI()(
set -- `fdp "$@"`
s="-I./ "`$p"$@"|sed -e 's/[^/]*$//g'|fu|sed -e 's/^/ -I/g'|fu|grep -v '^\-I$'|fU`
set -- `$p"$@"|awk '$0~/[.](h|hpp)$/{print}'|sed -e 's/[.][^.]*$/.o/'|fU`
buf="";for i;do test -f $i&&buf="$buf $i";done;
$p"$buf $s"
)

# 依存inc""を再帰的に取得./以下全て self系はkick
fdp()( l="$*"; paths="$@"; all=""; used=""
 while :;do
	all=`$p$all $paths|fU`	#差分を追加 repの始末 差分たちからaaa.hを取得 partial path
	buf=`(cat $paths|sed -ne 's@^[ \t]*#inc[^"]*.\([a-zA-Z0-9._]*\)".*@\1@p')|sort -u`
	ch=`$p$used $buf|tr -s ' ' '\n'|sort|uniq -u`	#使用済は外す
	used="$used $ch"	#リスト更新
	paths=`fsvy $ch|sort -u`	#ls検索 name系のみのはず
	buf=`$p"$all" "$paths"|fU`	#増えたらloop
	[ ${#all} = ${#buf} ]&&break
 done
# initを除く
 set -- $all
 for i;do a=${i##*[/]}; a=${a%%.*};[ "${l##*$a*}" = "$l" ]&&set -- "$@" $i;shift;done
 $p"$@"
)

# corecode:search + depthck + uniq
fsvy()(c="find -L ./ -false"
	for i; do c="$c -o -path '*'$i";done; l=`$e"$c"`
	for i; do $p"$l"|grep -F "$i"|awk '{sv=$0;print gsub("[/]","") " " sv}'|
	sort -k 1.1,1n -k 2.2,2|awk '{print $2;exit}'; done
)

# libをまとめる
fA()(n=0;dir=`dirname $0`/tmpdir;mkdir $dir;cd $dir;
 for i;do
 	n=$((n+1))
 	cp ../$i $i
 	ar -x $i
 	for ii in *.o;do mv "$ii" "p${n}_$ii";done
 	ar -r lib$bn.aa *.o
 	rm *.o
 done
 $p'mv lib$bn.aa ../lib$bn.a'|fv
 cd ..;rm -r $dir
)

#-- yacc
# /*SH_OP y $e"$CW";fy
# /*SH_OP Y $e"$Cy";fU $( ($p"lib$bn.a";fg $Rs $Rh)|$n|grep '[.]a$'|$U)
fy()(
cat<<'EEE'|fv
f0 "${C}YACC" "${C}YACCE"<$Rs>myyacc.y
f0 "${C}LEX" "${C}LEXE"<$Rs>mylex.l
lex mylex.l; yacc -p zz -dv myyacc.y
cat y.tab.c lex.yy.c > $Rs
gcc -c y.tab.c lex.yy.c -lfl `fA $Rs $Rh`
rm mylex.l myyacc.y lib$bn.a
ar r lib$bn.a `fo $Rs` y.tab.o lex.yy.o
$p"lib$bn.a"
EEE
)

#-- longcmd
frf()(
 awk -v r="${C##*]}rf" 'match($0,r){
 s=substr($0, RSTART+RLENGTH+1)
 gsub(/.[^*]*$/, "", s);split(s, a)
 m="[ -f %s ]&&echo \"/*--copyfrom %s*\"/&&cat %s&&echo \"/*--copyend %s*\"/"
 for(i=1;v=a[i];i++){ system( sprintf(m, v,v,v,v))}
 next
 }
 {print}'
)

ftt()(a="`sed -ne 's@^HCUT_ADD(\([^)]*\).*@\1, @p' $tf|tr -d '\n'`NULL"
	if [ $# != 0 ];then	a=""; for i;do a="$a $i,";done; a="$a NULL"; fi
	sed -ne "p;/_RUN/bl;d;:l;/[)]/{c\\$O $a)$O p;d};n;bl"<$tf>$Rm;mv $Rm $tf
	cat $Rs $tf>$Rm
)
i0=$e'fgr0 "^#ifdef TEST" "^#endif"<$R0|fbn>$tf'
i1=$e'fgR "^#ifdef TEST" "^#endif"<$Rs|fbn>$Rm;mv $Rm $Rs;fbn<$Rh>$Rm;mv $Rm $Rh'
fM()(
 valgrind -q --tool=massif --massif-out-file=./vmem.buf --stacks=yes --trace-children=yes $1>/dev/null
 ms_print ./vmem.buf|sed -ne '/[KMG]B/bl;d;:l;/snap/q;p;n;bl';rm ./vmem.buf)

/*SH_DE*/
